
/******************************************************************************
* MODULE     : mmlout.cpp
* DESCRIPTION: Standard output facilities and switches
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "interval.hpp"
namespace mml {

bool     interval_by_bounds= false;
nat      the_series_prec   = 10;
nat      the_series_zt     = 25;
bool     the_series_expr   = false;
void*    as_generic_aux_ptr= NULL;

generic&
the_series_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= new generic ("z");
  return *ptr;
}

generic&
the_polynomial_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= new generic ("x");
  return *ptr;
}

generic as_generic (int i) {
  return generic (i); }
generic as_generic (nat i) {
  return generic (as_string (integer (i))); }
generic as_generic (unsigned long int i) {
  return generic (as_string (integer (i))); }
generic as_generic (signed long int i) {
  return generic (as_string (integer (i))); }
generic as_generic (float x) {
  return generic (print_to_string (x)); }
generic as_generic (double x) {
  return generic (print_to_string (x)); }
generic as_generic (char* s) {
  return generic (s); }
generic as_generic (const string& s) {
  return generic (s); }
generic as_generic (const integer& i) {
  return generic (as_string (i)); }
generic as_generic (const rational& r) {
  return over (generic (as_string (num (r))), generic (as_string (den (r)))); }
generic as_generic (const generic& g) {
  return generic (g); }

} // namespace mml
