
/******************************************************************************
* MODULE     : pair.hpp
* DESCRIPTION: Pairs
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MML_PAIR_HPP
#define __MML_PAIR_HPP
#include "base.hpp"
namespace mml {
#define TMPL template<typename T, typename C>
#define Pair pair<T,C>

TMPL
class pair {
public:
  T key;
  C im;
  inline pair () {}
  inline pair (const T& key2, const C& im2): key (key2), im (im2) {}
};

TMPL inline nat
hash (const Pair& p) {
  nat h= hash (p.key);
  return (h<<1) ^ (h<<3) ^ (h<<9) ^ (h>>29) ^ hash (p.im);
}

TMPL inline generic
as_generic (const Pair& p) {
  return sqtuple (comma (as_generic (p.key), as_generic (p.im)));
}

PRINT_SUGAR(TMPL,Pair)

TMPL inline bool
operator == (const Pair& p1, const Pair& p2) {
  return (p1.key == p2.key) && (p1.im == p2.im);
}

TMPL inline bool
operator != (const Pair& p1, const Pair& p2) {
  return (p1.key != p2.key) || (p1.im != p2.im);
}

#undef TMPL
#undef Pair
} // namespace mml
#endif // __MML_PAIR_HPP
