
/******************************************************************************
* MODULE     : dyadic.cpp
* DESCRIPTION: Dyadic numbers
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "dyadic.hpp"
namespace mml {

dyadic lp_epsilon      = dyadic (0, DEFAULT_LOW);
dyadic lp_plus_infinity= dyadic::plus_infinity (DEFAULT_LOW);

ostream&
operator << (ostream& out, const dyadic& x) {
  return out << (*x);
}

generic
as_generic (const dyadic& g) {
  if (g < 0) return (negate (print_to_string (-g)));
  else return print_to_string (g);
}

} // namespace mml
