
/******************************************************************************
* MODULE     : interval_impl.hpp
* DESCRIPTION: low level subroutines for implementation of intervals
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MML_INTERVAL_IMPL_HPP
#define __MML_INTERVAL_IMPL_HPP
#include "interval.hpp"
namespace mml {

/******************************************************************************
* Helper class for mpfr floats (single precision by default)
******************************************************************************/

class direct_dyadic {
  mpfr_t x;
public:
  inline direct_dyadic () { mpfr_init2 (x, DEFAULT_LOW); }
  inline direct_dyadic (mp_prec_t prec) { mpfr_init2 (x, prec); }
  inline ~direct_dyadic () { mpfr_clear (x); }
  inline mpfr_t& operator * () { return x; }
};

}
#endif // __MML_INTERVAL_IMPL_HPP
