
/******************************************************************************
* MODULE     : interval_sint.cpp
* DESCRIPTION: Construct an interval from a dyadic
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

interval_rep::interval_rep (const dyadic& x, mp_prec_t prec) {
  if (is_zero (x)) {
    mpfr_init2 (min, DEFAULT_LOW);
    mpfr_init2 (max, DEFAULT_LOW);
    mpfr_set_si (max, 0, GMP_RNDU);
    mpfr_neg (min, max, GMP_RNDD);
  }
  else if (prec <= (DEFAULT_LOW + 2)) {
    mpfr_init2 (min, DEFAULT_LOW);
    mpfr_init2 (max, DEFAULT_LOW);
    mpfr_set (min, *x, GMP_RNDD);
    mpfr_set (max, *x, GMP_RNDU);
  }
  else {
    mpfr_init2 (mid, prec);
    mpfr_init2 (rad, DEFAULT_LOW);
    mpfr_set (mid, *x, GMP_RNDN);
    mpfr_set_ui_2si (rad, 1, mpfr_get_step (mid), GMP_RNDU);
  }
}

} // namespace mml
