
/******************************************************************************
* MODULE     : interval_min.cpp
* DESCRIPTION: Minimum of intervals
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

interval
min (const interval& x, const interval& y) {
  if (is_error (x)) return x;
  if (is_error (y)) return y;
  if (has_low_prec (x) && has_low_prec (y)) {
    interval_rep* r= raw_interval ();
    mpfr_min (r->min, x->min, y->min, GMP_RNDD);
    mpfr_min (r->max, x->max, y->max, GMP_RNDU);
    return r;
  }
  else {
    if (lower (x) <= lower (y)) // FIXME: avoid calls to "lower"
      return x; // FIXME: further improve if upper (x) > upper (y)
    else return y;
  }
}

} // namespace mml
