
/******************************************************************************
* MODULE     : approx_roots_test.cc
* DESCRIPTION: Computing (bounds for) approximate roots of polynomials
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "dyadic.hpp"
#include "approx_roots.hpp"
using namespace mml;

#define Real double
#define Complex complexify<Real >
#define Polynomial polynomial<Complex >

int
main () {
  Polynomial P= seq (Complex (1), Complex (5), Complex (2));
  P= P * q_difference (P, Complex (-1)) +
     Polynomial (Complex (Real (0.001)), 1);
  cout << "P\t= " << P << "\n";
  cout << "r\t= " << lower_bound_roots (P) << "\n";
  return 0;
}
