
/******************************************************************************
* MODULE     : real_min.cpp
* DESCRIPTION: Compute the minimum of two real numbers
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real.hpp"
namespace mml {

class min_real_rep: public real_rep {
private:
  real x, y;
public:
  inline min_real_rep (const real& x2, const real& y2):
    real_rep (weight (x2, y2)), x (x2), y (y2) { init (); }
  generic expression () const { return as_generic ("min", x, y); }
  void approx (const dyadic& err) {
    if (x->best < y->best) best= approx_linear (x, err);
    else if (y->best < x->best) best= approx_linear (y, err);
    else best= min (approx_linear (x, err), approx_linear (y, err)); }
};

real
min (const real& x, const real& y) {
  return real (new min_real_rep (x, y));
}

}
