
/******************************************************************************
* MODULE     : real_re.cpp
* DESCRIPTION: Real part of complex number
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "complex.hpp"
namespace mml {

class re_real_rep: public real_rep {
private:
  var_complex z;
public:
  inline re_real_rep (const var_complex& z2):
    real_rep (weight (z2)), z (z2) { init (); }
  generic expression () const {
    return as_generic ("Re", z->expression ()); }
  void approx (const dyadic& err) {
    best= Re (sq_approx (z, err)); }
};

real
Re (const var_complex& z) {
  return real (new re_real_rep (z));
}

}
