
/******************************************************************************
* MODULE     : real_sub.cpp
* DESCRIPTION: Subtraction of real numbers
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real.hpp"
namespace mml {

class sub_real_rep: public real_rep {
private:
  real x, y;
public:
  inline sub_real_rep (const real& x2, const real& y2):
    real_rep (weight (x2, y2)), x (x2), y (y2) { init (); }
  generic expression () const {
    return minus (as_generic (x), as_generic (y)); }
  void approx (const dyadic& err) {
    if (is_epsilon (x->best)) best= -approx_linear (y, err);
    else if (is_epsilon (y->best)) best= approx_linear (x, err);
    else best= approx_linear (x, spread (err, x->wt, wt)) -
	       approx_linear (y, spread (err, y->wt, wt)); }
};

real
operator - (const real& x, const real& y) {
  return real (new sub_real_rep (x, y), false);
}

}
