
/******************************************************************************
* MODULE     : real_test.cc
* DESCRIPTION: Test real numbers
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real.hpp"
using namespace mml;

int
main () {
  real x (1), y (2), z (3);
  cout << set_real_expr (true);
  cout << x << "\t0\t" << approx (x, 1.0) << "\n";
  cout << x << "\t40\t" << approx (x, 1.0e-40) << "\n";
  cout << x << "\t20\t" << approx (x, 1.0e-20) << "\n";
  cout << x << "\t45\t" << approx (x, 1.0e-45) << "\n";
  cout << x << "\t46\t" << approx (x, 1.0e-46) << "\n";
  cout << x << "\t100\t" << approx (x, 1.0e-100) << "\n";
  x= 4;
  y= x+x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  cout << y << "\t40\t" << approx (y, 1.0e-40) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  y= x-x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  cout << y << "\t40\t" << approx (y, 1.0e-40) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  y= x*x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  cout << y << "\t40\t" << approx (y, 1.0e-40) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  y= real(0)*x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  cout << y << "\t40\t" << approx (y, 1.0e-40) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  y= x/x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  cout << y << "\t40\t" << approx (y, 1.0e-40) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  /*
  y= x/(x-x);
  cout << y << "\t0\t" << approx (y, 1.0) << "\n";
  */
  y= -x;
  cout << x << "\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t20\t" << approx (y, 1.0e-20) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  x= -3;
  y= abs (x);
  cout << x << "\t\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t20\t" << approx (y, 1.0e-20) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  x= 3;
  y= x << 10;
  cout << x << "\t\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t20\t" << approx (y, 1.0e-20) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n";
  y= x >> 10;
  cout << x << "\t\t50\t" << approx (x, 1.0e-50) << "\n";
  cout << y << "\t20\t" << approx (y, 1.0e-20) << "\n";
  cout << y << "\t50\t" << approx (y, 1.0e-50) << "\n\n";

  y= real (12345);
  cout << x << "\t1e-10" << "\t" << approximate (x, 1e-10) << "\n";
  cout << y << "\t1e-10" << "\t" << approximate (y, 1e-10) << "\n";
  cout << x << "\t1e-20" << "\t" << approximate (x, 1e-20) << "\n";
  cout << x << "\t1e-30" << "\t" << approximate (x, 1e-30) << "\n";
  cout << x << "\t1e-50" << "\t" << approximate (x, 1e-50) << "\n\n";

  x= 3;
  y= 4;
  cout << "x\t\t= " << x << "\n";
  cout << "y\t\t= " << y << "\n";
  cout << "x=x\t\t= " << (x==x) << "\n";
  cout << "x<x\t\t= " << (x<x) << "\n";
  cout << "x<=x\t\t= " << (x<=x) << "\n";
  cout << "x=y\t\t= " << (x==y) << "\n";
  cout << "x!=y\t\t= " << (x!=y) << "\n";
  cout << "x<y\t\t= " << (x<y) << "\n";
  cout << "x<=y\t\t= " << (x<=y) << "\n";
  cout << "x>y\t\t= " << (x>y) << "\n";
  cout << "x>=y\t\t= " << (x>=y) << "\n";
  cout << min (x, y) << "\t= " << approximate (min (x, y), 1e-10) << "\n";
  cout << max (x, y) << "\t= " << approximate (max (x, y), 1e-10) << "\n\n";

  x= real (3) + real (7);
  y= real (2) * real (5);
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "x+y\t= " << x+y << "\n";
  cout << set_real_expr (false);
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "x+y\t= " << x+y << "\n\n";

  dyadic  d= 1.92837465;
  integer i= 111111111;
  x= as_real (d);
  y= real (i*i);
  z= real (rational (7) / rational (i));
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "z\t= " << z << "\n";
  cout << "x\t= " << approximate (x, 1e-50) << "\n";
  cout << "y\t= " << approximate (y, 1e-50) << "\n";
  cout << "z\t= " << approximate (z, 1e-50) << "\n";
  cout << "fl(x)\t= " << floor (x) << "\n";
  cout << "fl(y)\t= " << floor (y) << "\n";
  cout << "fl(z)\t= " << floor (z) << "\n";
  cout << "rnd(x)\t= " << round (x) << "\n";
  cout << "rnd(y)\t= " << round (y) << "\n";
  cout << "rnd(z)\t= " << round (z) << "\n";
  cout << "ce(x)\t= " << ceil (x) << "\n";
  cout << "ce(y)\t= " << ceil (y) << "\n";
  cout << "ce(z)\t= " << ceil (z) << "\n\n";

  x= real (2);
  y= real (100000);
  cout << "x\t\t= " << x << "\n";
  cout << "y\t\t= " << y << "\n";
  cout << "log (2)\t\t= " << real::log2 () << "\n";
  cout << "pi\t\t= " << real::pi () << "\n";
  cout << "gamma\t\t= " << real::euler () << "\n";
  cout << "sqrt (x)\t= " << sqrt (x) << "\n";
  cout << "sqrt (x)\t= " << approximate (sqrt (x), 1e-50) << "\n";
  cout << "sqrt (0)\t= " << sqrt (real (0)) << "\n";
  cout << "exp (x)\t\t= " << exp (x) << "\n";
  cout << "exp (y)\t\t= " << exp (y) << "\n";
  cout << "log (x)\t\t= " << log (x) << "\n";
  cout << "log (1)\t\t= " << log (real (1)) << "\n";
  cout << "cos (x)\t\t= " << cos (x) << "\n";
  cout << "cos (y)\t\t= " << cos (y) << "\n";
  cout << "sin (x)\t\t= " << sin (x) << "\n";
  cout << "tan (x)\t\t= " << tan (x) << "\n";
  cout << "asin (1/2)\t= " << asin (real (1) / real (2)) << "\n";
  cout << "asin (1-1/y)\t= " << asin (real (1) - real (1) / real (y)) << "\n";
  cout << "acos (1/2)\t= " << acos (real (1) / real (2)) << "\n";
  cout << "acos (1-1/y)\t= " << acos (real (1) - real (1) / real (y)) << "\n";
  cout << "atan (x)\t= " << atan (x) << "\n";
  cout << "atan (y)\t= " << atan (y) << "\n";
  cout << "atan2 (y, x)\t= " << atan2 (y, x) << "\n";
  cout << "atan2 (x, y)\t= " << atan2 (x, y) << "\n";
  cout << "atan2 (0, -x)\t= " << atan2 (real (0), -x) << "\n";
  return 0;
}
